"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = exports.builder = exports.desc = exports.aliases = exports.command = void 0;
var chalk_1 = __importDefault(require("chalk"));
var minimatch_1 = require("minimatch");
var ataraxia_1 = require("ataraxia");
var log_1 = require("../log");
var createNetwork_1 = require("../utils/createNetwork");
exports.command = 'listen';
exports.aliases = ['l'];
exports.desc = 'Listen for messages on the network';
var builder = function (yargs) {
    return yargs
        .usage('Usage: $0 listen [--filter message-type]')
        .option('type', {
        string: true,
        description: 'Optional filter to apply to message type, supports glob expressions'
    })
        .option('group', {
        string: true,
        description: 'Optional group to join'
    });
};
exports.builder = builder;
var handler = function (args) { return __awaiter(void 0, void 0, void 0, function () {
    var net, matcher;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                net = (0, createNetwork_1.createNetwork)(args);
                matcher = new minimatch_1.Minimatch((_a = args.type) !== null && _a !== void 0 ? _a : '*');
                net.onMessage(function (message) {
                    if (!matcher.match(message.type))
                        return;
                    (0, log_1.log)(chalk_1.default.green('<-'), chalk_1.default.blue(message.source.id), message.type);
                    (0, log_1.log)((0, log_1.indent)(2, message.data));
                });
                (0, log_1.logInfo)('Joining', chalk_1.default.magenta(net.name), 'as', chalk_1.default.blue(net.networkId));
                return [4 /*yield*/, net.join()];
            case 1:
                _b.sent();
                if (!args.exchange) return [3 /*break*/, 3];
                return [4 /*yield*/, new ataraxia_1.NamedGroup(net, args.group).join()];
            case 2:
                _b.sent();
                _b.label = 3;
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.handler = handler;
//# sourceMappingURL=listen.js.map