"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveAuth = void 0;
var ataraxia_1 = require("ataraxia");
/**
 * Resolve authentication to use based on command line arguments.
 *
 * @param args -
 *   parsed command line arguments
 * @returns
 *   array of auth providers
 */
function resolveAuth(args) {
    var result = [
        new ataraxia_1.AnonymousAuth()
    ];
    if (args.sharedKey) {
        result.push(new ataraxia_1.SharedSecretAuth({
            secret: args.sharedKey
        }));
    }
    return result;
}
exports.resolveAuth = resolveAuth;
//# sourceMappingURL=resolveAuth.js.map