"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stopNetwork = void 0;
var log_1 = require("../log");
/**
 * Stop a network and then exit the process.
 *
 * @param net -
 *   network to stop
 */
function stopNetwork(net) {
    net.leave()
        .then(function () { return process.exit(0); })
        .catch(function (err) {
        (0, log_1.logError)('Could not stop network gracefully', err.message);
        process.exit(0);
    });
}
exports.stopNetwork = stopNetwork;
//# sourceMappingURL=stopNetwork.js.map